--[[
************************************************************************
Project				: Broker_HitCrit
Author				: zhinjio
Project Revision	: 2.0-release
Project Date		: 20090530042148

File				: Broker_HitCrit.lua
Commit Author		: zhinjio
Commit Revision		: 28
Commit Date			: 20081203091743
************************************************************************
Description	:
	Main addon file. 

TODO		:
	Add in disable for vulnerable and low level mobs

************************************************************************
(see bottom of file for changelog)
************************************************************************
--]]

-- For now, we need a hack in here to make sure ace3 loads before I do.
-- All hail disembeded libraries and their swift return....
LoadAddOn("Ace3")

HitCrit_VERSION = 1.7

local HitCrit = LibStub( "AceAddon-3.0" ):NewAddon( "HitCrit", "AceEvent-3.0" )
local L = LibStub:GetLibrary( "AceLocale-3.0" ):GetLocale( "HitCrit" )
local AceConfig 		= LibStub("AceConfig-3.0")
local AceConfigReg 		= LibStub("AceConfigRegistry-3.0")
local AceConfigDialog 	= LibStub("AceConfigDialog-3.0")

local addonversion = "2.0-release"
local addonauthor = "zhinjio"
local builddate = "20090530042148"

_G["HitCrit"] = HitCrit
addon = HitCrit

local MODNAME = "HitCrit"
local modularOptions = {}
local tooltip
local LTT = LibStub:GetLibrary( "LibQTip-1.0" )

HitCrit.selCategory = 0
HitCrit.selSchool = 0
HitCrit.selEntry = 0
HitCrit.selEntryName = ""
HitCrit.selSpecific = 0
HitCrit.selSpecificName = ""

local db
local spellSchools = {
	[1]		= L["physical"],	-- 0x01	1	physical
	[2]		= L["holy"],		-- 0x02	2	holy
	[4]		= L["fire"],		-- 0x04	4	fire
	[8]		= L["nature"],		-- 0x08	8	nature
	[16]	= L["frost"],		-- 0x10	16	frost
	[20]	= L["frostfire"],	-- 0x18	20	frostfire
	[24]	= L["froststorm"],	-- 0x14	24	froststorm
	[32]	= L["shadow"],		-- 0x20	32	shadow
	[40]	= L["shadowstorm"],	-- 0x28	40	shadowstorm
	[64]	= L["arcane"],		-- 0x40	64	arcane
}

local resetExclusionList = {
	[33763]		= true,		-- LifeBloom, rank 1
	[48450]		= true,		-- LifeBloom, rank 2
	[48451]		= true,		-- LifeBloom, rank 3
}

function HitCrit_Print( msg )
	local _, fh = DEFAULT_CHAT_FRAME:GetFont()
	fh = math.ceil( fh )
	local icon = "\124TInterface\\Addons\\Broker_HitCrit\\icon:" .. fh .. "\124t"
	if ( msg ~= nil ) then
	   if( DEFAULT_CHAT_FRAME ) then
	      DEFAULT_CHAT_FRAME:AddMessage( icon .. " HitCrit: " .. msg, 0.6, 1.0, 1.0 )
	   end
	end
end

function HitCrit_Debug( msg )
	if ( msg ~= nil ) then
		if ( db.options.display.debug ) then
			HitCrit_Print( "DEBUG: " .. msg )
		end
	end
end

function HitCrit_Red( text )
	return "|cffff0000" .. text .. "|r"
end
function HitCrit_Yellow( text )
	return "|cffffff00" .. text .. "|r"
end
function HitCrit_Green( text )
	return "|cff00ff00" .. text .. "|r"
end
function HitCrit_White( text )
	return "|cffffffff" .. text .. "|r"
end
function HitCrit_hit( text)
	return "|cff00ffff" .. text .. "|r"
end
function HitCrit_crit( text)
	return "|cffff8080" .. text .. "|r"
end
function HitCrit_sch( text)
	return "|cffdfa050" .. text .. "|r"
end

function HitCrit:AlertNew( crit, heal, target, spellName, amount )
	local hType, hStr = L["Hit"], L["hit"]
	if ( heal == 1 ) then
		hStr = L["healed"]
		if ( crit == 1 ) then
			hType = L["Critical Heal"]
		else
			hType = L["Heal"]
		end
	else
		if ( crit == 1 ) then
			hType = L["Critical Hit"]
		end
	end
	if ( db.options.alerts.chatframe == true ) then
		HitCrit_Print( string.format( L["New Record %s! %s %s %s for %d"], hType, spellName, hStr, target, amount ) )
	end
	if ( db.options.alerts.notify == true ) then
		UIErrorsFrame:AddMessage( string.format( L["New Record %s! %s %s %s for %d"], hType, spellName, hStr, target, amount ) )
		-- Still need to figure this out
	end
	if ( db.options.alerts.sound == true ) then
		-- Still need to figure this out
		PlaySound("LEVELUPSOUND")
	end
	if ( db.options.alerts.screenie == true ) then
		Screenshot()
	end
end

function HitCrit_initHC( entry )
	entry.hit = {}; entry.crit = {}
	entry.total = 0
	entry.num = 0
	for i = 1, 3 do
		entry.hit[i] = {}
		entry.hit[i].value = 0
		entry.hit[i].name = ""
		entry.crit[i] = {}
		entry.crit[i].value = 0
		entry.crit[i].name = ""
	end
end

function HitCrit_initSpellEntry()
	local entry = {}
	entry.effect = ""
	entry.school = 0
	entry.rank = 0
	HitCrit_initHC( entry )
	return entry
end

function HitCrit_CheckInsertAlert( heal, id, hit, crit, dName, effect, sch )
	if ( effect ~= "" ) then
		if ( heal == 1 ) then side = "heal" else side = "damage" end
		if ( db.values[side][id] ) then
			local entry = db.values[side][id]
			-- this value already exists. Compare to current, and replace if needed
			if ( crit ~= 0 ) then
				entry.total = entry.total + crit
				entry.num = entry.num + 1
				entry.numcrit = entry.numcrit + 1
				if ( crit > entry.crit[1].value ) then
					entry.crit[3].value = entry.crit[2].value
					entry.crit[3].name = entry.crit[2].name
					entry.crit[2].value = entry.crit[1].value
					entry.crit[2].name = entry.crit[1].name
					entry.crit[1].value = crit
					entry.crit[1].name = dName
					HitCrit:AlertNew( 1, heal, dName, effect, crit )
				elseif ( crit > entry.crit[2].value ) then
					entry.crit[3].value = entry.crit[2].value
					entry.crit[3].name = entry.crit[2].name
					entry.crit[2].value = crit
					entry.crit[2].name = dName
				elseif ( crit > entry.crit[3].value ) then
					entry.crit[3].value = crit
					entry.crit[3].name = dName
				end
			else
				entry.total = entry.total + hit
				entry.num = entry.num + 1
				if ( hit > entry.hit[1].value ) then
					entry.hit[3].value = entry.hit[2].value
					entry.hit[3].name = entry.hit[2].name
					entry.hit[2].value = entry.hit[1].value
					entry.hit[2].name = entry.hit[1].name
					entry.hit[1].value = hit
					entry.hit[1].name = dName
					HitCrit:AlertNew( 0, heal, dName, effect, hit )
				elseif ( hit > entry.hit[2].value ) then
					entry.hit[3].value = entry.hit[2].value
					entry.hit[3].name = entry.hit[2].name
					entry.hit[2].value = hit
					entry.hit[2].name = dName
				elseif ( hit > entry.hit[3].value ) then
					entry.hit[3].value = hit
					entry.hit[3].name = dName
				end
			end
		else
			-- This could be a previously tracked spell, just with a new rank
			local sName, sRank = GetSpellInfo( id )
			local prevSpellID = 0
			if ( id ~= 0 ) then
				-- sName should match "effect" I believe 
				for k, v in pairs( db.values[side] ) do
					if ( v.effect == sName ) then
						if ( resetExclusionList[k] == true ) then
							-- this is a lifebloom (et al) type spell
							if ( resetExclusionList[id] ) then
								-- the new spell is also on the exclusion list. This is probably a down/uprank of the existing data
								if ( sRank ~= v.rank ) then
									prevSpellID = k
									break
								end
							else
								-- the new spell is NOT excluded. This is probably the "Bloom" effect. So don't exclude
							end
						else
							if ( sRank ~= v.rank ) then
								prevSpellID = k
								break
							else
								-- if we're here, someone is casting a downranked spell. Nub.
							end
						end
					end
				end
			end
			if ( prevSpellID ~= 0 ) then
				db.values[side][prevSpellID] = nil
			end

			-- Otherwise, we've got a new previously untracked value. Record all the info
			db.values[side][id] = {}
			local entry = HitCrit_initSpellEntry()
			entry.effect = effect
			entry.school = sch
			entry.rank = sRank
			entry.hit[1].value = hit
			entry.crit[1].value = crit
			if ( crit ~= 0 ) then
				entry.total = crit
				entry.num = 1
				entry.numcrit = 1
				entry.crit[1].name = dName
				HitCrit:AlertNew( 1, heal, dName, effect, crit )
			else
				entry.total = hit
				entry.num = 1
				entry.numcrit = 0
				entry.hit[1].name = dName
				HitCrit:AlertNew( 0, heal, dName, effect, hit )
			end
			db.values[side][id] = entry
		end
	end
	HitCrit:ChangeLabel()
end

function HitCrit:COMBAT_LOG_EVENT_UNFILTERED( _, _, eType, sGUID, sName, sFlags, dGUID, dName, dFlags, ... )
-- Parameters:
--	event		COMBAT_LOG_EVENT_UNFILTERED
--	timestamp
--	eType		event type (for example, SPELL_DAMAGE)
--	sGUID		source GUID
--	sName		source Name
--	sFlags		source Flags
--	dGUID		destination GUID
--	dName		destination Name
--	dFlags		destination Flags
--
--		The remaining parameters are dependent on eType
--
--		For RANGE_, SPELL_, SPELL_AURA_ and SPELL_PERIODIC_ prefixes, you have the following
--			spellId
--			spellName
--			spellSchool
--
--		Then, for _DAMAGE suffixes:
--			amount
--			overkill
--			school
--			resisted
--			blocked
--			absorbed
--			critical (1 or nil)
--			glancing (1 or nil)
--			crushing (1 or nil)
--
--		Then, for _HEAL suffixes:
--			amount
--			overhealing
--			critical
--
	local effect, id, hit, crit, sch, heal = "", 0, 0, 0, 0, 0
	local targetLevel = UnitLevel( "target" )
	if ( sGUID == HitCrit.GUID ) then
		-- First, check for damage
		if ( db.options.tracking.damage ) then
			if ( eType == "SWING_DAMAGE" ) then
				local amount, _, school, resisted, blocked, absorbed, critical, glance, crush = select( 1, ... )
				id = 0; effect = L["Melee"]; sch = school
				if ( critical == 1 ) then hit = 0; crit = amount else hit = amount; crit = 0 end
			elseif ( eType == "RANGE_DAMAGE" ) then
				local spellID, spellName, spellSchool, amount, overkill, school, resisted, blocked, absorbed, critical, glance, crush = select( 1, ... )
				id = spellID; effect = spellName; sch = spellSchool
				if ( critical == 1 ) then hit = 0; crit = amount else hit = amount; crit = 0 end
			elseif ( eType == "SPELL_DAMAGE" ) then
				local spellID, spellName, spellSchool, amount, overkill, school, resisted, blocked, absorbed, critical, glance, crush = select( 1, ... )
				id = spellID; effect = spellName; sch = spellSchool
				if ( critical == 1 ) then hit = 0; crit = amount else hit = amount; crit = 0 end
			elseif ( eType == "SPELL_AURA_DAMAGE" ) then
				-- does this event exist?
				local spellID, spellName, spellSchool, amount, overkill, school, resisted, blocked, absorbed, critical, glance, crush = select( 1, ... )
				id = spellID; effect = spellName; sch = spellSchool
				if ( critical == 1 ) then hit = 0; crit = amount else hit = amount; crit = 0 end
			elseif ( eType == "SPELL_PERIODIC_DAMAGE" ) then
				local spellID, spellName, spellSchool, amount, overkill, school, resisted, blocked, absorbed, crit, glance, crush = select( 1, ... )
				id = spellID; effect = spellName; sch = spellSchool
				if ( critical == 1 ) then hit = 0; crit = amount else hit = amount; crit = 0 end
			end
		end
		if ( db.options.tracking.healing ) then
			if ( eType == "SWING_HEAL" ) then
				-- does this event exist?
				local amount, overheal, crit = select( 1, ... )
				id = 0; effect = L["Melee"]; sch = 1; heal = 1
				if ( critical == 1 ) then hit = 0; crit = amount else hit = amount; crit = 0 end
			elseif ( eType == "RANGE_HEAL" ) then
				-- does this event exist?
				local spellID, spellName, spellSchool, amount, overheal, critical = select( 1, ... )
				id = spellID; effect = spellName; sch = spellSchool; heal = 1
				if ( critical == 1 ) then hit = 0; crit = amount else hit = amount; crit = 0 end
			elseif ( eType == "SPELL_HEAL" ) then
				local spellID, spellName, spellSchool, amount, overheal, critical = select( 1, ... )
				id = spellID; effect = spellName; sch = spellSchool; heal = 1
				if ( critical == 1 ) then hit = 0; crit = amount else hit = amount; crit = 0 end
			elseif ( eType == "SPELL_AURA_HEAL" ) then
				-- does this event exist?
				local spellID, spellName, spellSchool, amount, overheal, critical = select( 1, ... )
				id = spellID; effect = spellName; sch = spellSchool; heal = 1
				if ( critical == 1 ) then hit = 0; crit = amount else hit = amount; crit = 0 end
			elseif ( eType == "SPELL_PERIODIC_HEAL" ) then
				local spellID, spellName, spellSchool, amount, overheal, critical = select( 1, ... )
				id = spellID; effect = spellName; sch = spellSchool; heal = 1
				if ( critical == 1 ) then hit = 0; crit = amount else hit = amount; crit = 0 end
			end
		end
	elseif ( ( db.options.tracking.againstMe == true ) and ( dGUID == HitCrit.GUID ) ) then
	end

	local ignoreHit = false
	if ( db.options.tracking.lowlevel == false ) then
		if ( ( HitCrit.level - targetLevel ) >= 7 ) then
			ignoreHit = true
		end
	end
	if ( ( heal == 0 ) and ( dName == HitCrit.me ) ) then
		-- This is an effect like Judgement of the Martyr where hitting someone else transfers some
		-- damage to me. Ignore those
		ignoreHit = true
	end
	if ( ignoreHit == false ) then
		HitCrit_CheckInsertAlert( heal, id, hit, crit, dName, effect, sch )
	end
end

local LDB = LibStub( "LibDataBroker-1.1" )
local launcher = LDB:NewDataObject( "HitCrit", {
	type = "launcher",
	text = "",
	label = "Broker_HitCrit",
	icon = "Interface\\Addons\\Broker_HitCrit\\icon",
	OnClick = function(clickedframe, button)
				if button == "RightButton" then
					HitCrit:ShowConfig()
				else
					HitCrit_Browser_Frame:Show()
				end
	end,
	OnEnter = function ( self )
		tooltip:Clear()
		local t = {}
		t[1] = 3
		t[2] = "LEFT"
		if ( db.options.display.avg ) then t[1] = t[1] + 2; table.insert( t, "CENTER" ); table.insert( t, "RIGHT" ) end
		if ( db.options.display.hit ) then t[1] = t[1] + 2; table.insert( t, "CENTER" ); table.insert( t, "RIGHT" ) end
		if ( db.options.display.crit ) then t[1] = t[1] + 2; table.insert( t, "CENTER" ); table.insert( t, "RIGHT" ) end
		if ( db.options.display.enemyName ) then t[1] = t[1] + 2; table.insert( t, "CENTER" ); table.insert( t, "RIGHT" ) end
		tooltip:SetColumnLayout( unpack( t ) )

		tooltip:AddHeader( HitCrit_White( L["Broker_HitCrit"] ) )

		local t = {}
		if ( db.options.display.type ) then
			-- sort by damage school
			local schools = {}; schools.damage = {}; schools.healing = {}
			for k, v in pairs( spellSchools ) do schools.damage[k] = {}; schools.healing[k] = {} end
			for k, v in pairs( db.values["damage"] ) do
				schools.damage[v.school][k] = true
			end
			for k, v in pairs( db.values["heal"] ) do
				schools.healing[v.school][k] = true
			end
			-- damage block
			tooltip:AddLine( HitCrit_Red( "  " .. L["Damage"] ) )
			t = {}
			table.insert( t, HitCrit_White( "    " .. L["Effect"] ) )
			if ( db.options.display.avg ) then table.insert( t, " " ); table.insert( t, HitCrit_White( L["Avg"] ) ) end
			if ( db.options.display.hit ) then table.insert( t, " " ); table.insert( t, HitCrit_White( L["Hit"] ) ) end
			if ( db.options.display.crit ) then table.insert( t, " " ); table.insert( t, HitCrit_White( L["Crit"] .. "(%)" ) ) end
			if ( db.options.display.enemyName ) then table.insert( t, " " ); table.insert( t, HitCrit_White( L["Against"] ) ) end
			tooltip:AddLine( unpack( t ) )
			for k, v in pairs( spellSchools ) do
				if ( next( schools.damage[k] ) ~= nil ) then
					tooltip:AddLine( HitCrit_sch( "    " .. v ) )
					for m, u in pairs( schools.damage[k] ) do
						local i = db.values["damage"][m]
						local e, h, c, a = i.effect, i.hit[1].value, i.crit[1].value, floor( i.total / i.num )
						local cp = ""
						if ( ( i.num ~= 0 ) and ( i.numcrit ~= 0 ) ) 
							then cp = string.format( "(%.1f%%)", ( i.numcrit / i.num * 100 ) )
						end
						if ( i.num == 0 ) then a = " " end
						t = nil; t = {}
						table.insert( t, HitCrit_Yellow( "      " .. e ) )
						if ( db.options.display.avg ) then table.insert( t, " " ); table.insert( t, HitCrit_Yellow( a ) ) end
						if ( db.options.display.hit ) then table.insert( t, " " ); table.insert( t, HitCrit_hit( h ) ) end
						if ( db.options.display.crit ) then table.insert( t, " " ); table.insert( t, HitCrit_crit( c .. cp ) ) end
						if ( db.options.display.enemyName ) then 
							if ( c ~= 0 ) then
								table.insert( t, " " ); table.insert( t, HitCrit_crit( i.crit[1].name ) )
							else
								table.insert( t, " " ); table.insert( t, HitCrit_hit( i.hit[1].name ) )
							end
						end
						tooltip:AddLine( unpack( t ) )
					end
				end
			end
			-- healing block
			tooltip:AddLine( HitCrit_Green( "  " .. L["Healing"] ) )
			t = {}
			table.insert( t, HitCrit_White( "    " .. L["Effect"] ) )
			if ( db.options.display.avg ) then table.insert( t, " " ); table.insert( t, HitCrit_White( L["Avg"] ) ) end
			if ( db.options.display.hit ) then table.insert( t, " " ); table.insert( t, HitCrit_White( L["Hit"] ) ) end
			if ( db.options.display.crit ) then table.insert( t, " " ); table.insert( t, HitCrit_White( L["Crit"] .. "(%)" ) ) end
			if ( db.options.display.enemyName ) then table.insert( t, " " ); table.insert( t, HitCrit_White( L["Against"] ) ) end
			tooltip:AddLine( unpack( t ) )
			for k, v in pairs( spellSchools ) do
				if ( next( schools.healing[k] ) ~= nil ) then
					tooltip:AddLine( HitCrit_sch( "    " .. v ) )
					for m, n in pairs( schools.healing[k] ) do
						local i = db.values["heal"][m]
						local e, h, c, a = i.effect, i.hit[1].value, i.crit[1].value, floor( i.total / i.num )
						local cp = ""
						if ( ( i.num ~= 0 ) and ( i.numcrit ~= 0 ) ) 
							then cp = string.format( "(%.1f%%)", ( i.numcrit / i.num * 100 ) )
						end
						if ( i.num == 0 ) then a = " " end
						t = nil; t = {}
						table.insert( t, HitCrit_Yellow( "      " .. e ) )
						if ( db.options.display.avg ) then table.insert( t, " " ); table.insert( t, HitCrit_Yellow( a ) ) end
						if ( db.options.display.hit ) then table.insert( t, " " ); table.insert( t, HitCrit_hit( h ) ) end
						if ( db.options.display.crit ) then table.insert( t, " " ); table.insert( t, HitCrit_crit( c .. cp ) ) end
						if ( db.options.display.enemyName ) then 
							if ( c ~= 0 ) then
								table.insert( t, " " ); table.insert( t, HitCrit_crit( i.crit[1].name ) )
							else
								table.insert( t, " " ); table.insert( t, HitCrit_hit( i.hit[1].name ) )
							end
						end
						tooltip:AddLine( unpack( t ) )
					end
				end
			end
		else
			-- damage header lines
			tooltip:AddLine( HitCrit_Red( "  " .. L["Damage"] ) )
			table.insert( t, HitCrit_White( "    " .. L["Effect"] ) )
			if ( db.options.display.avg ) then table.insert( t, " " ); table.insert( t, HitCrit_White( L["Avg"] ) ) end
			if ( db.options.display.hit ) then table.insert( t, " " ); table.insert( t, HitCrit_White( L["Hit"] ) ) end
			if ( db.options.display.crit ) then table.insert( t, " " ); table.insert( t, HitCrit_White( L["Crit"] .. "(%)" ) ) end
			if ( db.options.display.enemyName ) then table.insert( t, " " ); table.insert( t, HitCrit_White( L["Against"] ) ) end
			tooltip:AddLine( unpack( t ) )
			-- loop through damage
			for k, v in pairs( db.values["damage"] ) do
				local e, h, c, a = v.effect, v.hit[1].value, v.crit[1].value, floor( v.total / v.num )
				local cp = ""
				if ( ( v.num ~= 0 ) and ( v.numcrit ~= 0 ) ) 
					then cp = string.format( "(%.1f%%)", ( v.numcrit / v.num * 100 ) )
				end
				if ( v.num == 0 ) then a = " " end
				t = nil; t = {}
				table.insert( t, HitCrit_Yellow( "    " .. e ) )
				if ( db.options.display.avg ) then table.insert( t, " " ); table.insert( t, HitCrit_Yellow( a ) ) end
				if ( db.options.display.hit ) then table.insert( t, " " ); table.insert( t, HitCrit_hit( h ) ) end
				if ( db.options.display.crit ) then table.insert( t, " " ); table.insert( t, HitCrit_crit( c .. cp ) ) end
				if ( db.options.display.enemyName ) then 
					if ( c ~= 0 ) then
						table.insert( t, " " ); table.insert( t, HitCrit_crit( v.crit[1].name ) )
					else
						table.insert( t, " " ); table.insert( t, HitCrit_hit( v.hit[1].name ) )
					end
				end
				tooltip:AddLine( unpack( t ) ) 
			end
			-- healing header lines
			tooltip:AddLine( HitCrit_Green( "  " .. L["Healing"] ) )
			t = nil; t = {}
			table.insert( t, HitCrit_White( "    " .. L["Effect"] ) )
			if ( db.options.display.avg ) then table.insert( t, " " ); table.insert( t, HitCrit_White( L["Avg"] ) ) end
			if ( db.options.display.hit ) then table.insert( t, " " ); table.insert( t, HitCrit_White( L["Hit"] ) ) end
			if ( db.options.display.crit ) then table.insert( t, " " ); table.insert( t, HitCrit_White( L["Crit"] .. "(%)" ) ) end
			if ( db.options.display.enemyName ) then table.insert( t, " " ); table.insert( t, HitCrit_White( L["Against"] ) ) end
			tooltip:AddLine( unpack( t ) )
			-- loop through healing
			for k, v in pairs( db.values["heal"] ) do
				local e, h, c, a = v.effect, v.hit[1].value, v.crit[1].value, floor( v.total / v.num )
				local cp = ""
				if ( ( v.num ~= 0 ) and ( v.numcrit ~= 0 ) ) 
					then cp = string.format( "(%.1f%%)", ( v.numcrit / v.num * 100 ) )
				end
				if ( v.num == 0 ) then a = " " end
				t = nil; t = {}
				table.insert( t, HitCrit_Yellow( "    " .. e ) )
				if ( db.options.display.avg ) then table.insert( t, " " ); table.insert( t, HitCrit_Yellow( a ) ) end
				if ( db.options.display.hit ) then table.insert( t, " " ); table.insert( t, HitCrit_hit( h ) ) end
				if ( db.options.display.crit ) then table.insert( t, " " ); table.insert( t, HitCrit_crit( c .. cp ) ) end
				if ( db.options.display.enemyName ) then 
					if ( c ~= 0 ) then
						table.insert( t, " " ); table.insert( t, HitCrit_crit( v.crit[1].name ) )
					else
						table.insert( t, " " ); table.insert( t, HitCrit_hit( v.hit[1].name ) )
					end
				end
				tooltip:AddLine( unpack( t ) ) 
			end
		end
		-- Add menu items
		tooltip:AddLine(" ")
		tooltip:AddLine( HitCrit_Yellow( L["Left-click for Data Browser"] ) )
		tooltip:AddLine( HitCrit_Yellow( L["Right-click for Configuration"] ) )

		tooltip:SmartAnchorTo( self )
		tooltip:Show()
	end,
	OnLeave = function ( )
		tooltip:Hide()
	end,
} )

function HitCrit_upgradeDB()
	local olddb = HitCrit.db.factionrealm[HitCrit.me]
	-- This checks the current DB version the person has, and upgrades as necessary
	if not ( olddb.options.display.dbVersion ) then
		-- They have the original version
		local values = {}; values["damage"] = {}; values["heal"] = {}
		local side = "damage"
		for k, v in pairs( olddb.values ) do
			HitCrit_Debug( "id/h/c/dmg/sch/eff = "..k.."/"..v.hit.."/"..v.crit.."/"..
				v.dmg.."/"..v.school.."/"..v.effect )
			if ( v.dmg == 1 ) then side = "damage" else side = "heal" end
			local entry = HitCrit_initSpellEntry()
			_, sRank = GetSpellInfo( k )
			entry.school = v.school
			entry.effect = v.effect
			entry.rank = sRank
			entry.total = 0
			entry.num = 0
			entry.hit[1].value = v.hit
			entry.crit[1].value = v.crit
			if ( v.hit == 0 ) then entry.hit[1].name = "" else entry.hit[1].name = v.target end
			if ( v.crit == 0 ) then entry.crit[1].name = "" else entry.crit[1].name = v.target end
			values[side][k] = entry
		end
		olddb.values = nil
		olddb.values = values
		olddb.options.display.dbVersion = "1.1"
		HitCrit_Print( string.format( L["Database upgraded to %s"], "1.1" ) )
	end
	if ( olddb.options.display.dbVersion == "1.1" ) then
		olddb.options.tracking.lowlevel = false
		olddb.options.display.dbVersion = "1.2"
		HitCrit_Print( string.format( L["Database upgraded to %s"], "1.2" ) )
	end
	if ( olddb.options.display.dbVersion == "1.2" ) then
		olddb.options.display.avg = true
		olddb.options.display.dbVersion = "1.3"
		HitCrit_Print( string.format( L["Database upgraded to %s"], "1.3" ) )
	end
	if ( olddb.options.display.dbVersion == "1.3" ) then
		olddb.options.display.fontsize = nil
		olddb.options.display.tipscale = 1
		olddb.options.display.dbVersion = "1.4"
		HitCrit_Print( string.format( L["Database upgraded to %s"], "1.4" ) )
	end
	if ( olddb.options.display.dbVersion == "1.4" ) then
		olddb.options.alerts.screenie = false
		olddb.options.display.dbVersion = "1.5"
		HitCrit_Print( string.format( L["Database upgraded to %s"], "1.5" ) )
	end
	if ( olddb.options.display.dbVersion == "1.5" ) then
		olddb.options.display.debug = false
		olddb.options.display.dbVersion = "1.6"
		HitCrit_Print( string.format( L["Database upgraded to %s"], "1.6" ) )
	end
	if ( olddb.options.display.dbVersion == "1.6" ) then
		-- reset totals for each damage and healing entry, and add in the numcrit field
		for k, v in pairs( olddb.values["heal"] ) do
			v.total = 0
			v.num = 0
			v.numcrit = 0
		end
		for k, v in pairs( olddb.values["damage"] ) do
			v.total = 0
			v.num = 0
			v.numcrit = 0
		end
		olddb.options.display.debug = false
		olddb.options.display.dbVersion = "1.7"
		HitCrit_Print( string.format( L["Database upgraded to %s"], "1.7" ) )
	end
	if ( olddb.options.display.dbVersion == "1.7" ) then
		olddb.options.display.label = false
		olddb.options.display.labelHeal = false
		olddb.options.display.dbVersion = "1.8"
		HitCrit_Print( string.format( L["Database upgraded to %s"], "1.8" ) )
	end
end

function HitCrit:ChangeLabel()
	-- default value
	launcher.text = ""
	local dbd = db.options.display
	if ( dbd.label == true ) then
		-- by default, we display damage
		local tophit, topcrit = 0, 0
		if ( dbd.labelHeal == true ) then
			for k, v in pairs( db.values["heal"] ) do
				if ( v.hit[1].value > tophit ) then tophit = v.hit[1].value end
				if ( v.crit[1].value > topcrit ) then topcrit = v.crit[1].value end
			end
		else
			for k, v in pairs( db.values["damage"] ) do
				if ( v.hit[1].value > tophit ) then tophit = v.hit[1].value end
				if ( v.crit[1].value > topcrit ) then topcrit = v.crit[1].value end
			end
		end
		launcher.text = tophit .. "/" .. topcrit
	end
end

local alertOptions = nil
local displayOptions = nil
local trackingOptions = nil

-- options stuff
local function giveTracking()
	if (not trackingOptions) then
		trackingOptions = {
			order = 2,
			type = "group",
			name = L["Tracking Options"],
			desc = L["TRACKING_OPTIONS_DESC"],
			args = {
				header1 = {
					order	= 21,
					type	= "header",
					name	= L["Tracking Options"],
				},
				desc = {
					order	= 22,
					type	= "description",
					name	= L["TRACKING_OPTIONS_DESC"],
				},
				pvp = {
					order	= 23,
					type	= "toggle",
					name	= L["Track PvP"],
					desc	= L["TRACK_PVP_DESC"],
					get		= function() return db.options.tracking.pvp end,
					set		= function() db.options.tracking.pvp = not db.options.tracking.pvp end,
					disabled = true,
				},
				againstMe = {
					order	= 24,
					type	= "toggle",
					name	= L["Track Hits Against Me"],
					desc	= L["TRACK_AGAINSTME_DESC"],
					get		= function() return db.options.tracking.againstMe end,
					set		= function() db.options.tracking.againstMe = not db.options.tracking.againstMe end,
					disabled = true,
				},
				damage = {
					order	= 25,
					type	= "toggle",
					name	= L["Track Damage"],
					desc	= L["TRACK_DAMAGE_DESC"],
					get		= function() return db.options.tracking.damage end,
					set		= function() db.options.tracking.damage = not db.options.tracking.damage end,
				},
				healing = {
					order	= 26,
					type	= "toggle",
					name	= L["Track Healing"],
					desc	= L["TRACK_HEALING_DESC"],
					get		= function() return db.options.tracking.healing end,
					set		= function() db.options.tracking.healing = not db.options.tracking.healing end,
				},
				environmental = {
					order	= 27,
					type	= "toggle",
					name	= L["Track Environmental"],
					desc	= L["TRACK_ENVIRONMENTAL_DESC"],
					get		= function() return db.options.tracking.environmental end,
					set		= function() db.options.tracking.environmental = not db.options.tracking.environmental end,
					disabled = true,
				},
				vulnerable = {
					order	= 28,
					type	= "toggle",
					name	= L["Track Vulnerable"],
					desc	= L["TRACK_VULNERABLE_DESC"],
					get		= function() return db.options.tracking.vulnerable end,
					set		= function() db.options.tracking.vulnerable = not db.options.tracking.vulnerable end,
					disabled = true,
				},
				lowlevel = {
					order	= 28,
					type	= "toggle",
					name	= L["Track Low Level"],
					desc	= L["TRACK_LOWLEVEL_DESC"],
					get		= function() return db.options.tracking.lowlevel end,
					set		= function() db.options.tracking.lowlevel = not db.options.tracking.lowlevel end,
				},
			},
		}
	end
	return trackingOptions
end

local function giveDisplay()
	if (not displayOptions) then
		displayOptions = {
			order = 3,
			type = "group",
			name = L["Display Options"],
			desc = L["DISPLAY_OPTIONS_DESC"],
			args = {
				header1 = {
					order	= 31,
					type	= "header",
					name	= L["Display Options"],
				},
				desc = {
					order	= 32,
					type	= "description",
					name	= L["DISPLAY_OPTIONS_DESC"],
				},
				avg = {
					order	= 33,
					type	= "toggle",
					name	= L["Display Avg"],
					desc	= L["DISPLAY_AVG_DESC"],
					get		= function() return db.options.display.avg end,
					set		= function() db.options.display.avg = not db.options.display.avg end,
				},
				hit = {
					order	= 34,
					type	= "toggle",
					name	= L["Display Hit"],
					desc	= L["DISPLAY_HIT_DESC"],
					get		= function() return db.options.display.hit end,
					set		= function() db.options.display.hit = not db.options.display.hit end,
				},
				crit = {
					order	= 35,
					type	= "toggle",
					name	= L["Display Crit"],
					desc	= L["DISPLAY_CRIT_DESC"],
					get		= function() return db.options.display.crit end,
					set		= function() db.options.display.crit = not db.options.display.crit end,
				},
				enemyName = {
					order	= 36,
					type	= "toggle",
					name	= L["Display Enemy Name"],
					desc	= L["DISPLAY_ENEMYNAME_DESC"],
					get		= function() return db.options.display.enemyName end,
					set		= function() db.options.display.enemyName = not db.options.display.enemyName end,
				},
				school = {
					order	= 37,
					type	= "toggle",
					name	= L["Sort by School"],
					desc	= L["DISPLAY_SORTSCHOOL_DESC"],
					get		= function() return db.options.display.type end,
					set		= function() db.options.display.type = not db.options.display.type end,
				},
				debug = {
					order	= 38,
					type	= "toggle",
					name	= L["Display Debug"],
					desc	= L["DISPLAY_DEBUG_DESC"],
					get		= function() return db.options.display.debug end,
					set		= function() db.options.display.debug = not db.options.display.debug end,
				},
				label = {
					order	= 39,
					type	= "toggle",
					name	= L["Display Top Values in Label"],
					desc	= L["DISPLAY_LABEL_DESC"],
					get		= function() return db.options.display.label end,
					set		= function()
								db.options.display.label = not db.options.display.label
								HitCrit:ChangeLabel()
							  end,									
				},
				labelHeal = {
					order	= 40,
					type	= "toggle",
					name	= L["Display Heal in Label"],
					desc	= L["DISPLAY_LABELHEAL_DESC"],
					get		= function() return db.options.display.labelHeal end,
					set		= function()
								db.options.display.labelHeal = not db.options.display.labelHeal
								HitCrit:ChangeLabel()
							  end,
					disabled	= function() return not db.options.display.label end,
				},
				tooltipscale = {
					order	= 41,
					type	= "range",
					name	= L["Tooltip Scale"],
					desc	= L["TOOLTIP_SCALE_DESC"],
					min		= .7,
					max		= 1.3,
					step	= .05,
					bigStep = .05,
					get		= function() return db.options.display.tipscale end,
					set		= function( info, v ) 
								db.options.display.tipscale = v
								tooltip:SetScale( v )
							  end,
				},
			},
		}
	end
	return displayOptions
end

local function giveAlert()
	if (not alertOptions) then
		alertOptions = {
			order = 4,
			type = "group",
			name = L["Alert Options"],
			desc = L["ALERT_OPTIONS_DESC"],
			args = {
				header1 = {
					order	= 41,
					type	= "header",
					name	= L["Alert Options"],
				},
				desc = {
					order	= 42,
					type	= "description",
					name	= L["ALERT_OPTIONS_DESC"],
				},
				sound = {
					order	= 43,
					type	= "toggle",
					name	= L["Alert with Sound"],
					desc	= L["ALERT_SOUND_DESC"],
					get		= function() return db.options.alerts.sound end,
					set		= function() db.options.alerts.sound = not db.options.alerts.sound end,
				},
				notify = {
					order	= 44,
					type	= "toggle",
					name	= L["Alert with Notify"],
					desc	= L["ALERT_NOTIFY_DESC"],
					get		= function() return db.options.alerts.notify end,
					set		= function() db.options.alerts.notify = not db.options.alerts.notify end,
				},
				chatframe = {
					order	= 45,
					type	= "toggle",
					name	= L["Alert in Chat Frame"],
					desc	= L["ALERT_CHATFRAME_DESC"],
					get		= function() return db.options.alerts.chatframe end,
					set		= function() db.options.alerts.chatframe = not db.options.alerts.chatframe end,
				},
				screenie = {
					order	= 46,
					type	= "toggle",
					name	= L["Take Screenshot"],
					desc	= L["ALERT_SCREENIE_DESC"],
					get		= function() return db.options.alerts.screenie end,
					set		= function() db.options.alerts.screenie = not db.options.alerts.screenie end,
				},
			},
		}
	end
	return alertOptions
end

local options = nil
local function fullOptions()
	if (not options) then
		options = {
			type = "group",
			name = MODNAME,
			args = {
				general = {
					order	= 1,
					type	= "group",
					name	= L["General Information"],
					desc	= L["GENERAL_INFO_DESC"],
					args	= {
						header1 = {
							order	= 11,
							type	= "header",
							name	= L["General Information"],
						},
						desc = {
							order	= 12,
							type	= "description",
							name	= L["GENERAL_INFO_DESC"],
						},
						author = {
							order	= 13,
							type	= "description",
							name	= L["Author : "] .. addonauthor .. "\n",
						},
						version = {
							order	= 14,
							type	= "description",
							name	= L["Version : "] .. addonversion .. "\n",
						},
						builddate = {
							order	= 15,
							type	= "description",
							name	= L["Build Date : "] .. builddate .. "\n",
						},
						dbversion = {
							order	= 15,
							type	= "description",
							name	= L["Database Version : "] .. db.options.display.dbVersion .. "\n",
						},
						translators = {
							order	= 16,
							type	= "description",
							name	= string.format( L["Helpful Translators (thank you) : %s"], "SunTsu(deDE)" ) .. "\n",
						},
					},
				},
			},
		}
	end
	
	for k,v in pairs(modularOptions) do
		options.args[k] = (type(v) == "function") and v() or v
	end

	return options
end

function addon:SetupOptions()
	AceConfigReg:RegisterOptionsTable(MODNAME, fullOptions)
	self.optionsFrame = AceConfigDialog:AddToBlizOptions(MODNAME, nil, nil, "general")

	-- Fill up our modular options...
	self:RegisterModuleOptions("Tracking", giveTracking(), L["Tracking Options"])
	self:RegisterModuleOptions("Display", giveDisplay(), L["Display Options"])
	self:RegisterModuleOptions("Alert", giveAlert(), L["Alert Options"])
end

function addon:RegisterModuleOptions(name, optionsTable, displayName)
	modularOptions[name] = optionsTable
	self.optionsFrame[name] = AceConfigDialog:AddToBlizOptions(MODNAME, displayName, MODNAME, name)
end

function HitCrit:ShowConfig()
	-- Open the profiles tab before, so the menu expands
	InterfaceOptionsFrame_OpenToCategory( self.optionsFrame["Display"] )
end

local function HC_TooltipDisplay( this, textLabel )
	this:SetScript( "OnEnter",
		function ( this )
			GameTooltip_SetDefaultAnchor( GameTooltip, this )
			GameTooltip:SetText( textLabel, HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b )
			GameTooltip:Show()
		end
	)
	this:SetScript( "OnLeave",
		function( this )
			GameTooltip:Hide()
		end
	)
end

local function HC_CreateButton(
	bName, parentFrame,	bHeight, bWidth,
	anchorFrom, anchorFrame, anchorTo, xOffset, yOffset,
	bNormFont, bHighFont, initText, tAlign, tooltipText )

	-- I hate stretchy buttons. Thanks very much to ckknight for this code
	-- (found in RockConfig)

	-- when pressed, the button should look pressed
	local function button_OnMouseDown(this)
		if this:IsEnabled() == 1 then
			this.left:SetTexture([[Interface\Buttons\UI-Panel-Button-Down]])
			this.middle:SetTexture([[Interface\Buttons\UI-Panel-Button-Down]])
			this.right:SetTexture([[Interface\Buttons\UI-Panel-Button-Down]])
		end
	end
	-- when depressed, return to normal
	local function button_OnMouseUp(this)
		if this:IsEnabled() == 1 then
			this.left:SetTexture([[Interface\Buttons\UI-Panel-Button-Up]])
			this.middle:SetTexture([[Interface\Buttons\UI-Panel-Button-Up]])
			this.right:SetTexture([[Interface\Buttons\UI-Panel-Button-Up]])
		end
	end

	local function button_Disable(this)
		this.left:SetTexture([[Interface\Buttons\UI-Panel-Button-Disabled]])
		this.middle:SetTexture([[Interface\Buttons\UI-Panel-Button-Disabled]])
		this.right:SetTexture([[Interface\Buttons\UI-Panel-Button-Disabled]])
		this:__Disable()
		this:EnableMouse(false)
	end

	local function button_Enable(this)
		this.left:SetTexture([[Interface\Buttons\UI-Panel-Button-Up]])
		this.middle:SetTexture([[Interface\Buttons\UI-Panel-Button-Up]])
		this.right:SetTexture([[Interface\Buttons\UI-Panel-Button-Up]])
		this:__Enable()
		this:EnableMouse(true)
	end

	local button = CreateFrame( "Button", bName, parentFrame )

	button:SetWidth( bWidth )
	button:SetHeight( bHeight )

	local left = button:CreateTexture(button:GetName() .. "_LeftTexture", "BACKGROUND")
	button.left = left
	local middle = button:CreateTexture(button:GetName() .. "_MiddleTexture", "BACKGROUND")
	button.middle = middle
	local right = button:CreateTexture(button:GetName() .. "_RightTexture", "BACKGROUND")
	button.right = right

	left:SetTexture([[Interface\Buttons\UI-Panel-Button-Up]])
	middle:SetTexture([[Interface\Buttons\UI-Panel-Button-Up]])
	right:SetTexture([[Interface\Buttons\UI-Panel-Button-Up]])

	left:SetPoint("TOPLEFT")
	left:SetPoint("BOTTOMLEFT")
	left:SetWidth(12)
	left:SetTexCoord(0, 0.09375, 0, 0.6875)

	right:SetPoint("TOPRIGHT")
	right:SetPoint("BOTTOMRIGHT")
	right:SetWidth(12)
	right:SetTexCoord(0.53125, 0.625, 0, 0.6875)

	middle:SetPoint("TOPLEFT", left, "TOPRIGHT")
	middle:SetPoint("BOTTOMRIGHT", right, "BOTTOMLEFT")
	middle:SetTexCoord(0.09375, 0.53125, 0, 0.6875)

	button:SetScript("OnMouseDown", button_OnMouseDown)
	button:SetScript("OnMouseUp", button_OnMouseUp)
	button:SetScript("OnEnter", SubControl_OnEnter)
	button:SetScript("OnLeave", SubControl_OnLeave)

	button.__Enable = button.Enable
	button.__Disable = button.Disable
	button.Enable = button_Enable
	button.Disable = button_Disable

	local highlight = button:CreateTexture(button:GetName() .. "_Highlight", "OVERLAY", "UIPanelButtonHighlightTexture")
	button:SetHighlightTexture(highlight)

	local text = button:CreateFontString(button:GetName() .. "_FontString", "ARTWORK")
	button:SetFontString(text)
	button.text = text
	text:SetPoint("LEFT", button, "LEFT", 7, 0)
	text:SetPoint("RIGHT", button, "RIGHT", -7, 0)
	text:SetJustifyH( tAlign )

	button:SetNormalFontObject(bNormFont)
	button:SetHighlightFontObject(bHighFont)
	button:SetDisabledFontObject(GameFontDisableSmall)

	text:SetText( initText )		

	button:SetPoint( anchorFrom, anchorFrame, anchorTo, xOffset, yOffset )
	if ( tooltipText ~= "" ) then
		HC_TooltipDisplay( button, tooltipText )
	end

	return button
end

function HC_CreateDiv( bName, parentFrame,	bHeight, bWidth,
	anchorFrom, anchorFrame, anchorTo, xOffset, yOffset )

	local button = CreateFrame( "Button", bName, parentFrame )
		button:SetHeight( bHeight )
		button:SetWidth( bWidth )
		button:SetPoint( anchorFrom, anchorFrame, anchorTo, xOffset, yOffset )
		local distex = button:CreateTexture( "distex", "ARTWORK" )
--		button:SetDisabledTexture( [[Interface\MailFrame\UI-MailFrame-InvoiceLine]] )
		button:SetDisabledTexture( [[Interface\Addons\Broker_HitCrit\div]] )
		distex:SetAllPoints( button )
		button:Disable()

	return button
end

function HCBF_DD_Category_Initialize()
	info.text = L["Damage"]
	info.arg1 = 1
	info.arg2 = info.text
	info.func = HCBF_DD_Category_OnClick
	info.checked = ( HitCrit.selCategory == 1 )
	UIDropDownMenu_AddButton( info )
	info.text = L["Healing"]
	info.arg1 = 2
	info.arg2 = info.text
	info.func = HCBF_DD_Category_OnClick
	info.checked = ( HitCrit.selCategory == 2 )
	UIDropDownMenu_AddButton( info )
end

function HCBF_DD_Category_OnClick( button, value, text )
	CloseDropDownMenus()
	HCBF_DD_CategoryText:SetText( text )
	HitCrit.selCategory = value
	HCBF_ResetCategoryButton:Enable()
	-- Populate second tier dropdown based on selection and enable
	UIDropDownMenu_EnableDropDown( HCBF_DD_School )
	HitCrit.selSchool = 0
	HCBF_DD_SchoolText:SetText( "" )
	HCBF_DD_School_Initialize()
	HCBF_ResetSchoolButton:Disable()
	-- Disable further dropdowns
	HitCrit.selEntry = 0
	HCBF_DD_EntryText:SetText( "" )
	UIDropDownMenu_DisableDropDown( HCBF_DD_Entry )
	HCBF_ResetEntryButton:Disable()
	HitCrit.selSpecific = 0
	HCBF_DD_SpecificText:SetText( "" )
	UIDropDownMenu_DisableDropDown( HCBF_DD_Specific )
	HCBF_ResetSpecificButton:Disable()
end

function HCBF_DD_School_Initialize( )
	local schools = {}
	local dbc = {}
	if ( HitCrit.selCategory == 1 ) then
		dbc = db.values.damage
	else
		dbc = db.values.heal
	end
	for k, v in pairs( dbc ) do
		schools[v.school] = true
	end
	for k, v in pairs( schools ) do
		info.text = spellSchools[k]
		info.arg1 = k
		info.arg2 = info.text
		info.func = HCBF_DD_School_OnClick
		info.checked = ( HitCrit.selSchool == k )
		UIDropDownMenu_AddButton( info )
	end
end

function HCBF_DD_School_OnClick( button, value, text )
	CloseDropDownMenus()
	HCBF_DD_SchoolText:SetText( text )
	HitCrit.selSchool = value
	HCBF_ResetSchoolButton:Enable()
	-- Populate the third tier dropdown
	UIDropDownMenu_EnableDropDown( HCBF_DD_Entry )
	HitCrit.selEntry = 0
	HCBF_DD_EntryText:SetText( "" )
	HCBF_DD_Entry_Initialize()
	HCBF_ResetEntryButton:Disable()
	-- Disable anything after that
	HitCrit.selSpecific = 0
	HCBF_DD_SpecificText:SetText( "" )
	UIDropDownMenu_DisableDropDown( HCBF_DD_Specific )
	HCBF_ResetSpecificButton:Disable()
end

function HCBF_DD_Entry_Initialize()
	local dbc = {}
	if ( HitCrit.selCategory == 1 ) then
		dbc = db.values.damage
	else
		dbc = db.values.heal
	end
	for k, v in pairs( dbc ) do
		if ( v.school == HitCrit.selSchool ) then
			info.text = v.effect
			info.arg1 = k
			info.arg2 = info.text
			info.func = HCBF_DD_Entry_OnClick
			info.checked = ( HitCrit.selEntry == k )
			UIDropDownMenu_AddButton( info )
		end
	end
end

function HCBF_DD_Entry_OnClick( button, value, text )
	CloseDropDownMenus()
	HCBF_DD_EntryText:SetText( text )
	HitCrit.selEntry = value
	HitCrit.selEntryName = text
	HCBF_ResetEntryButton:Enable()
	-- Populate final dropdown
	UIDropDownMenu_EnableDropDown( HCBF_DD_Specific )
	HitCrit.selSpecific = 0
	HCBF_DD_SpecificText:SetText( "" )
	HCBF_DD_Specific_Initialize()
	HCBF_ResetSpecificButton:Disable()
end

function HCBF_DD_Specific_Initialize()
	local dbc = {}
	if ( HitCrit.selCategory == 1 ) then
		dbc = db.values.damage
	else
		dbc = db.values.heal
	end
	-- "Hit for xxx against yyy"
	for i = 1, 3 do
		v = dbc[HitCrit.selEntry].hit[i].value
		if ( v > 0 ) then
			n = dbc[HitCrit.selEntry].hit[i].name
			info.text = string.format( L["%s for %s against %s"], L["Hit"], v, n )
			info.arg1 = i
			info.arg2 = info.text
			info.func = HCBF_DD_Specific_OnClick
			info.checked = ( HitCrit.selSpecific == i )
			UIDropDownMenu_AddButton( info )
		end
	end
	for i = 1, 3 do
		v = dbc[HitCrit.selEntry].crit[i].value
		if ( v > 0 ) then
			n = dbc[HitCrit.selEntry].crit[i].name
			info.text = string.format( L["%s for %s against %s"], L["Crit"], v, n )
			info.arg1 = i + 3
			info.arg2 = info.text
			info.func = HCBF_DD_Specific_OnClick
			info.checked = ( HitCrit.selSpecific == ( i + 3 ) )
			UIDropDownMenu_AddButton( info )
		end
	end
end

function HCBF_DD_Specific_OnClick( button, value, text )
	CloseDropDownMenus()
	HCBF_DD_SpecificText:SetText( text )
	HitCrit.selSpecific = value
	HitCrit.selSpecificName = text
	HCBF_ResetSpecificButton:Enable()
end

function HitCrit_Browser_Frame_OnShow()
	HCBF_DD_Category_OnClick( self, 0, L["Damage"] )
end

function HitCrit_ResetData()
	-- If we're here, the user already confirmed. Nuke away...
	if ( HitCrit.resetType == 1 ) then
		-- Reset all data for this toon
		db.values = nil
		db.values = {}
		db.values.damage = {}
		db.values.heal = {}
	elseif ( HitCrit.resetType == 2 ) then
		-- Reset all data either in "damage" or "heal"
		if ( HitCrit.selCategory == 1 ) then
			db.values.damage = nil
			db.values.damage = {}
		else
			db.values.heal = nil
			db.values.heal = {}
		end
	elseif ( HitCrit.resetType == 3 ) then
		-- Reset all "damage" or "heal" data for a specific school
		local dbc = {}
		if ( HitCrit.selCategory == 1 ) then
			dbc = db.values.damage
		else
			dbc = db.values.heal
		end
		for k, v in pairs( dbc ) do
			if ( v.school == HitCrit.selSchool ) then
				dbc[k] = nil
			end
		end
	elseif ( HitCrit.resetType == 4 ) then
		-- Reset all data for specific spell
		local dbc = {}
		if ( HitCrit.selCategory == 1 ) then
			dbc = db.values.damage
		else
			dbc = db.values.heal
		end
		dbc[ HitCrit.selEntry ] = nil
	else
		-- Reset only one entry from a specific spell
		local dbc = {}
		if ( HitCrit.selCategory == 1 ) then
			dbc = db.values.damage
		else
			dbc = db.values.heal
		end
		local entry = dbc[ HitCrit.selEntry ]
		local hTable = "hit"
		local hIndex = HitCrit.selSpecific
		if ( HitCrit.selSpecific > 3 ) then
			hIndex = HitCrit.selSpecific - 3
			hTable = "crit"
		end
		if ( hIndex == 1 ) then
			entry[ hTable ][1].value = entry[ hTable ][2].value
			entry[ hTable ][1].name = entry[ hTable ][2].name
			entry[ hTable ][2].value = entry[ hTable ][3].value
			entry[ hTable ][2].name = entry[ hTable ][3].name
		elseif ( hIndex == 2 ) then
			entry[ hTable ][2].value = entry[ hTable ][3].value
			entry[ hTable ][2].name = entry[ hTable ][3].name
		end
		entry[ hTable ][3].value = 0
		entry[ hTable ][3].name = ""
	end
	-- Reset out browser frame
	HitCrit_Browser_Frame:Hide()

	HitCrit.selCategory = 0
	HitCrit.selSchool = 0
	HitCrit.selEntry = 0
	HitCrit.selSpecific = 0

	HCBF_DD_CategoryText:SetText( "" )
	HCBF_DD_SchoolText:SetText( "" )
	HCBF_DD_EntryText:SetText( "" )
	HCBF_DD_SpecificText:SetText( "" )

	HCBF_ResetCategoryButton:Disable()
	HCBF_ResetSchoolButton:Disable()
	HCBF_ResetEntryButton:Disable()
	HCBF_ResetSpecificButton:Disable()

	UIDropDownMenu_DisableDropDown( HCBF_DD_School )
	UIDropDownMenu_DisableDropDown( HCBF_DD_Entry )
	UIDropDownMenu_DisableDropDown( HCBF_DD_Specific )
	HitCrit:ChangeLabel()
end

-- Added a static popup for confirmation of delete actions...
StaticPopupDialogs["HC_CONFIRM_RESET_DATA"] = {
	text = "",
	button1 = L["Yes"],
	button2 = L["No"],
	OnAccept = function()
		HitCrit_ResetData()
	end,
	EditBoxOnEscapePressed = function()
		this:GetParent():Hide()
	end,
	timeout = 0,
	exclusive = 1,
	whileDead = 1,
	hideOnEscape = 1
}

function HCBF_ResetAllButton_OnClick()
	HitCrit.resetType = 1
	StaticPopupDialogs["HC_CONFIRM_RESET_DATA"].text =
		string.format( L["Reset ALL data for '%s'. Are you sure?"], HitCrit.me )
	StaticPopup_Show( "HC_CONFIRM_RESET_DATA" )
end

function HCBF_ResetCategoryButton_OnClick()
	HitCrit.resetType = 2
	local c = ""
	if ( HitCrit.selCategory == 1 ) then c = "Damage" else c = "Heal" end
	StaticPopupDialogs["HC_CONFIRM_RESET_DATA"].text =
		string.format( L["Reset data for '%s' - Category: %s. Are you sure?"], HitCrit.me, c )
	StaticPopup_Show( "HC_CONFIRM_RESET_DATA" )
end

function HCBF_ResetSchoolButton_OnClick()
	HitCrit.resetType = 3
	local c = ""
	if ( HitCrit.selCategory == 1 ) then c = "Damage" else c = "Heal" end
	local s = spellSchools[ HitCrit.selSchool ]
	StaticPopupDialogs["HC_CONFIRM_RESET_DATA"].text =
		string.format( L["Reset data for '%s' - Category: %s, School: %s. Are you sure?"], HitCrit.me, c, s )
	StaticPopup_Show( "HC_CONFIRM_RESET_DATA" )
end

function HCBF_ResetEntryButton_OnClick()
	HitCrit.resetType = 4
	local e = HitCrit.selEntryName
	StaticPopupDialogs["HC_CONFIRM_RESET_DATA"].text =
		string.format( L["Reset data for '%s' - Spell: %s. Are you sure?"], HitCrit.me, e )
	StaticPopup_Show( "HC_CONFIRM_RESET_DATA" )
end

function HCBF_ResetSpecificButton_OnClick()
	HitCrit.resetType = 5
	local e = HitCrit.selSpecificName
	StaticPopupDialogs["HC_CONFIRM_RESET_DATA"].text =
		string.format( L["Reset data for '%s' - '%s'. Are you sure?"], HitCrit.me, e )
	StaticPopup_Show( "HC_CONFIRM_RESET_DATA" )
end

function HitCrit_CreateFrames()
	local FrameWidth = 410
	HitCrit_Browser_Frame = CreateFrame( "Frame", "HitCrit_Browser_Frame", UIParent )
	HitCrit_Browser_Frame:Hide()
	HitCrit_Browser_Frame:SetHeight( 245 )
	HitCrit_Browser_Frame:SetWidth( FrameWidth )
	HitCrit_Browser_Frame:SetPoint( "CENTER", UIParent, "CENTER", 0, 0 )
	HitCrit_Browser_Frame:EnableMouse( true )
	HitCrit_Browser_Frame:SetMovable( false )
	HitCrit_Browser_Frame:SetFrameLevel( 1 )
	HitCrit_Browser_Frame:SetFrameStrata( "FULLSCREEN_DIALOG" )
	HitCrit_Browser_Frame:SetHitRectInsets( 4, 4, 4, 4 )
	local bgFrame = {insets = {}}
	bgFrame.bgFile = "Interface/Tooltips/UI-Tooltip-Background"
	bgFrame.edgeFile = "Interface/Tooltips/UI-Tooltip-Border"
	bgFrame.tile = true
	bgFrame.tileSize = 16
	bgFrame.edgeSize = 16
	bgFrame.insets.left = 4
	bgFrame.insets.right = 4
	bgFrame.insets.top = 4
	bgFrame.insets.bottom = 4
	HitCrit_Browser_Frame:SetBackdrop(bgFrame)
	HitCrit_Browser_Frame:SetBackdropColor( 0, 0, 0, 1 )

	--Allows this to be closed with the Escape key
	tinsert( UISpecialFrames, "HitCrit_Browser_Frame" )

	local HCBF_CloseButton = CreateFrame( "Button", "HCBF_CloseButton", HitCrit_Browser_Frame, "UIPanelCloseButton" )
		HCBF_CloseButton:SetFrameLevel( 5 )
		HCBF_CloseButton:SetScript( "OnClick",
			function(this)
				this:GetParent():Hide()
			end
		)
		HCBF_CloseButton:SetPoint( "TOPRIGHT", HitCrit_Browser_Frame, "TOPRIGHT", 3, 3 )

	local HCBF_TitleText = HitCrit_Browser_Frame:CreateFontString( "HCBF_TitleText", "OVERLAY", "GameFontHighlightLarge" )
		HCBF_TitleText:SetText( L["HitCrit Data Browser"] )
		HCBF_TitleText:SetPoint( "TOP", HitCrit_Browser_Frame, "TOP", 0, -10 )
		HCBF_TitleText:SetHeight( 16 )
		HCBF_TitleText:SetWidth( FrameWidth )

	local HCBF_div1 = HC_CreateDiv( "HCBF_div1", HitCrit_Browser_Frame, 1, FrameWidth-50,
		"TOP", HCBF_TitleText, "BOTTOM", 0, -5 )

	local HCBF_ResetAllButton = HC_CreateButton( "HCBF_ResetAllButton", HitCrit_Browser_Frame, 22, 160,
		"TOP", HCBF_div1, "BOTTOM", 0, -5, "GameFontNormalSmall", "GameFontHighlightSmall",
		L["Reset All Data"], "CENTER", L["RESETALL_TOOLTIP"] )

	local HCBF_div2 = HC_CreateDiv( "HCBF_div2", HitCrit_Browser_Frame, 1, FrameWidth-50,
		"TOP", HCBF_ResetAllButton, "BOTTOM", 0, -5 )

	HCBF_DD_Category = CreateFrame( "Frame", "HCBF_DD_Category", HitCrit_Browser_Frame, "UIDropDownMenuTemplate" )
		HCBF_DD_Category:SetPoint( "TOPLEFT", HitCrit_Browser_Frame, "TOPLEFT", 5, -69 )
		HCBF_DD_Category:SetHitRectInsets(16, 16, 0, 0)
		UIDropDownMenu_SetWidth( HCBF_DD_Category, 160 )
		UIDropDownMenu_EnableDropDown( HCBF_DD_Category )

	HCBF_ResetCategoryButton = HC_CreateButton( "HCBF_ResetCategoryButton", HitCrit_Browser_Frame, 22, 160,
		"TOPRIGHT", HitCrit_Browser_Frame, "TOPRIGHT", -25, -71, "GameFontNormalSmall", "GameFontHighlightSmall",
		L["Reset Category Data"], "CENTER", L["RESETCATEGORY_TOOLTIP"] )
		HCBF_ResetCategoryButton:Disable()

	local HCBF_div3 = HC_CreateDiv( "HCBF_div3", HitCrit_Browser_Frame, 1, FrameWidth-50,
		"TOP", HCBF_div2, "BOTTOM", 0, -35 )

	HCBF_DD_School = CreateFrame( "Frame", "HCBF_DD_School", HitCrit_Browser_Frame, "UIDropDownMenuTemplate" )
		HCBF_DD_School:SetPoint( "TOPLEFT", HCBF_DD_Category, "BOTTOMLEFT", 0, -4 )
		HCBF_DD_School:SetHitRectInsets(16, 16, 0, 0)
		UIDropDownMenu_SetWidth( HCBF_DD_School, 160 )
		UIDropDownMenu_DisableDropDown( HCBF_DD_School )

	HCBF_ResetSchoolButton = HC_CreateButton( "HCBF_ResetSchoolButton", HitCrit_Browser_Frame, 22, 160,
		"TOPRIGHT", HCBF_ResetCategoryButton, "BOTTOMRIGHT", 0, -14, "GameFontNormalSmall", "GameFontHighlightSmall",
		L["Reset School Data"], "CENTER", L["RESETSCHOOL_TOOLTIP"] )
		HCBF_ResetSchoolButton:Disable()

	local HCBF_div4 = HC_CreateDiv( "HCBF_div4", HitCrit_Browser_Frame, 1, FrameWidth-50,
		"TOP", HCBF_div3, "BOTTOM", 0, -35 )

	HCBF_DD_Entry = CreateFrame( "Frame", "HCBF_DD_Entry", HitCrit_Browser_Frame, "UIDropDownMenuTemplate" )
		HCBF_DD_Entry:SetPoint( "TOPLEFT", HCBF_DD_School, "BOTTOMLEFT", 0, -4 )
		HCBF_DD_Entry:SetHitRectInsets(16, 16, 0, 0)
		UIDropDownMenu_SetWidth( HCBF_DD_Entry, 160 )
		UIDropDownMenu_DisableDropDown( HCBF_DD_Entry )
		
	HCBF_ResetEntryButton = HC_CreateButton( "HCBF_ResetEntryButton", HitCrit_Browser_Frame, 22, 160,
		"TOPRIGHT", HCBF_ResetSchoolButton, "BOTTOMRIGHT", 0, -14, "GameFontNormalSmall", "GameFontHighlightSmall",
		L["Reset Entry Data"], "CENTER", L["RESETENTRY_TOOLTIP"] )
		HCBF_ResetEntryButton:Disable()

	local HCBF_div5 = HC_CreateDiv( "HCBF_div5", HitCrit_Browser_Frame, 1, FrameWidth-50,
		"TOP", HCBF_div4, "BOTTOM", 0, -35 )

	HCBF_DD_Specific = CreateFrame( "Frame", "HCBF_DD_Specific", HitCrit_Browser_Frame, "UIDropDownMenuTemplate" )
		HCBF_DD_Specific:SetPoint( "TOP", HCBF_div5, "BOTTOM", 0, -5 )
		HCBF_DD_Specific:SetHitRectInsets(16, 16, 0, 0)
		UIDropDownMenu_SetWidth( HCBF_DD_Specific, 300 )
		UIDropDownMenu_DisableDropDown( HCBF_DD_Specific )

	HCBF_ResetSpecificButton = HC_CreateButton( "HCBF_ResetSpecificButton", HitCrit_Browser_Frame, 22, 160,
		"TOP", HCBF_DD_Specific, "BOTTOM", 0, -2, "GameFontNormalSmall", "GameFontHighlightSmall",
		L["Reset Specific Data"], "CENTER", L["RESETSPECIFIC_TOOLTIP"] )
		HCBF_ResetSpecificButton:Disable()
		
	HCBF_DD_Category.initialize = HCBF_DD_Category_Initialize
	HCBF_DD_School.initialize = HCBF_DD_School_Initialize
	HCBF_DD_Entry.initialize = HCBF_DD_Entry_Initialize
	HCBF_DD_Specific.initialize = HCBF_DD_Specific_Initialize

	HCBF_ResetAllButton:SetScript( "OnClick", HCBF_ResetAllButton_OnClick )
	HCBF_ResetCategoryButton:SetScript( "OnClick", HCBF_ResetCategoryButton_OnClick )
	HCBF_ResetSchoolButton:SetScript( "OnClick", HCBF_ResetSchoolButton_OnClick )
	HCBF_ResetEntryButton:SetScript( "OnClick", HCBF_ResetEntryButton_OnClick )
	HCBF_ResetSpecificButton:SetScript( "OnClick", HCBF_ResetSpecificButton_OnClick )
end

function HitCrit:OnInitialize()
	HitCrit_CreateFrames()
end

function HitCrit:OnEnable()
    -- Called when the addon is loaded
	HitCrit.me = UnitName( "player" )
	HitCrit.GUID = UnitGUID( "player" )
	HitCrit.level = UnitLevel( "player" )

	self.db = LibStub( "AceDB-3.0" ):New( "HitCrit_DB", nil, "Default" )
	-- do we have any data yet; for this toon? If not, init its table
	if not ( self.db.factionrealm[HitCrit.me] ) then
		self.db.factionrealm[HitCrit.me] = {
			options = {
				tracking = {
					pvp = false,
					againstMe = false,
					damage = true,
					healing = true,
					environmental = false,
					vulnerable = false,
					lowlevel = false,
				},
				display = {
					hit = true,
					crit = true,
					avg = true,
					enemyName = false,
					type = false,
					debug = false,
					tipscale = 1,
					dbVersion = "1.8",
					label = false,
					labelHeal = false,
				},
				alerts = {
					sound = false,
					notify = false,
					chatframe = true,
					screenie = false,
				},
			},
			values = {
				damage = {},
				heal = {},
			}
		}
	else
		-- check if we need to upgrade the db
		HitCrit_upgradeDB()
	end
	db = self.db.factionrealm[HitCrit.me]

	HitCrit_Debug( "In OnInit" )

	tooltip = LTT:Acquire( "HitCritTT", 7, "LEFT", "CENTER", "RIGHT", "CENTER", "RIGHT", "CENTER", "RIGHT" ) -- or GameTooltip
	tooltip:SetScale( db.options.display.tipscale )

	HitCrit:SetupOptions()
	HitCrit:ChangeLabel()
	-- Event listeners
    HitCrit:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
end

--[[
************************************************************************
CHANGELOG:

Data : 12/02/08
	added ability display top hit/crit values in text of display
Date : 11/17/08
	added data browser and the ability to remove data points

Date : 11/15/08
	changed font size to tooltip scaling in options == win

Date : 10/29/08
	Initial version
************************************************************************
]]--